package com.google.user;

import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

//
@Controller
public class UserListController {
	private List<User> userList = new ArrayList<User>();

	@RequestMapping(value = "/adduser.htm", method = RequestMethod.GET)
	public String showForm() {
		return "adduser";
	}

	@RequestMapping(value = "/adduser.htm", method = RequestMethod.POST)
	public @ResponseBody String addUser(@ModelAttribute(value = "user") User user, BindingResult result) {
		String returnText;
		if (!result.hasErrors()) {
			userList.add(user);
			returnText = "User has been added to the list. Total number of users are "
					+ userList.size();
		} else {
			returnText = "Sorry, an error has occur. User has not been added to list.";
		}
		return returnText;
	}

	@RequestMapping(value = "/showusers.htm")
	public String showUsers(ModelMap model) {
		model.addAttribute("Users", userList);
		return "showusers";
	}
	
	// json ------------------------
	
	@RequestMapping(value = "/adduser-json.htm", method = RequestMethod.GET)
	public String showFormJson() {
		return "adduser-json";
	}

	@RequestMapping(value = "/adduser-json.htm", method = RequestMethod.POST)
	public @ResponseBody JsonResponse addUserJson(@ModelAttribute(value = "user") User user, BindingResult result) {
		JsonResponse res = new JsonResponse();
	    if(!result.hasErrors()){
	        userList.add(user);
	        res.setStatus("SUCCESS");
	    }else{
	        res.setStatus("FAIL");
	    }
	   res.setResult(user);
	   return res;
	}
}
